package org.springblade.third.doordevice.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.third.doordevice.entity.QinlinConfig;
import org.springblade.third.doordevice.vo.QinlinConfigVO;
import org.springblade.third.doordevice.wrapper.QinlinConfigWrapper;
import org.springblade.third.doordevice.service.IQinlinConfigService;

import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-04-27
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/qinlinconfig")

public class QinlinConfigClient implements IQinlinConfigClient {

    private final IQinlinConfigService qinlinConfigService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public QinlinConfigVO detail(@SpringQueryMap QinlinConfig qinlinConfig) {
        QinlinConfig detail = qinlinConfigService.getOne(Condition.getQueryWrapper(qinlinConfig));
        return QinlinConfigWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<QinlinConfigVO> list(QinlinConfig qinlinConfig) {
        return QinlinConfigWrapper.build().listVO(qinlinConfigService.list(Condition.getQueryWrapper(qinlinConfig)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody QinlinConfig qinlinConfig) {
        return qinlinConfigService.save(qinlinConfig);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody QinlinConfig qinlinConfig) {
        return qinlinConfigService.updateById(qinlinConfig);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody QinlinConfig qinlinConfig) {
        return qinlinConfigService.saveOrUpdate(qinlinConfig);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return qinlinConfigService.deleteLogic(Func.toLongList(ids));
        }


}
